<?php
/**
* Joomla Community Builder MySQL Field Type Plugin: plug_cbmysqlfield
* @version $Id$
* @package plug_cbmysqlfield
* @subpackage cb.mysqlfield.php
* @author Joe Palmer
* @copyright (C) 2010 www.softforge.co.uk
* @license Limited http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
* @final 1.2
*/

/** ensure this file is being included by a parent file */
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

global $_PLUGINS;
$_PLUGINS->loadPluginGroup( 'user', array( (int) 1 ) );
$_PLUGINS->registerUserFieldTypes( array( 'mysqlfield' => 'CBfield_mysql' ) );
$_PLUGINS->registerUserFieldParams();

class CBfield_mysql extends CBfield_counter {
	/**
	 * Returns a field in specified format
	 *
	 * @param  moscomprofilerFields  $field
	 * @param  moscomprofilerUser    $user
	 * @param  string                $output  'html', 'xml', 'json', 'php', 'csvheader', 'csv', 'rss', 'fieldslist', 'htmledit'
	 * @param  string                $reason  'profile' for user profile view, 'edit' for profile edit, 'register' for registration, 'list' for user-lists
	 * @param  int                   $list_compare_types   IF reason == 'search' : 0 : simple 'is' search, 1 : advanced search with modes, 2 : simple 'any' search
	 * @return mixed                
	 */
	function getField( &$field, &$user, $output, $reason, $list_compare_types ) {
		global $_CB_framework, $ueConfig, $_CB_database;

		$oReturn = null;
		
		$fieldtype = $field->params->get( 'fieldType', 'single' );
		$fielddisplay = $field->params->get( 'fieldDisplay', 'all' );
		$fieldsubstitute = $field->params->get( 'fieldSubstitute', 'no' );
		$viewer =& JFactory::getUser();
		
		if (($viewer->id == $user->id && $fielddisplay != "viewer") || ($viewer->id != $user->id && $fielddisplay != "user")) {
	
		    // Built MySQL Query
		    $query = "SELECT " . $field->params->get( 'fieldSelect', '' ) . " AS mysqlfield";
		    $query .= " FROM " . $field->params->get( 'fieldFrom', '' );
		    $fieldwhere = $field->params->get( 'fieldWhere', '' );
		    if($fieldwhere != '') {
               $query .= " WHERE " . $fieldwhere;
		    }
			$fieldorder = $field->params->get( 'fieldOrder', '' );
		    if($fieldorder != '' && $fieldtype == 'multi') {
               $query .= " ORDER BY " . $fieldorder;
		    }
			$fieldlimit = $field->params->get( 'fieldLimit', '' );
		    if($fieldlimit != '' && $fieldtype == 'multi') {
               $query .= " LIMIT " . $fieldlimit;
		    }
		    $_CB_database->setQuery(str_replace("{USERID}", $user->id, str_replace("{VIEWERID}", $viewer->id, $query)));
            
		    $fieldprefix = $field->params->get( 'fieldPrefix', '' );
		    $fielddelimiter = $field->params->get( 'fieldDelimiter', '' );
            $fieldsuffix = $field->params->get( 'fieldSuffix', '' );
            
            if($fieldtype == 'single') {
            	$value = $_CB_database->loadResult();
            } else {
            	$results = $_CB_database->loadObjectList();
            	if(count($results) > 0) {
            		$first = true;            	
	            	foreach ($results as $result) {
	            		if ($first == true) {
	            			$value = $result->mysqlfield;
	            			$first = false;
	            		} else {
	            			$value .= $fielddelimiter . $result->mysqlfield;
	            		}
	            	}
            	} else {
            		$value = null;
            	}	
            }
            
            if ( $value != '' ) {
                $value = $fieldprefix . $value . $fieldsuffix;
                $fieldmode = $field->params->get( 'fieldMode', 'display' );
                $fieldsavename = $field->params->get( 'fieldSaveName', '' );
                
                if ( $fieldmode != 'display' ) {
                	$_CB_database->setQuery( "UPDATE #__comprofiler SET " . $fieldsavename . " = '" . $value . "' WHERE user_id = " . $user->id );
                	$_CB_database->query();
                	if ( $fieldmode == 'save' ) {
                		$value = null;
                	}
                }
            } else {
            	$value = null;
            }
		} else {
			$value = null;
		}
		
		if ( $value && $fieldsubstitute != "no" ) {
			if ( $fieldsubstitute == "viewer" ) {
				$usersub =& CBUser::getInstance( (int)$viewer->id );
			} else {
				$usersub =& CBUser::getInstance( (int)$user->id );
			}
			$value = $usersub->replaceUserVars( $value );
		}

		switch ( $output ) {
			case 'html':
			case 'rss':
				$oReturn				=	$value;
				break;
	
			case 'htmledit':
				// $oReturn				=	parent::getField( $field, $user, $output, $reason, $list_compare_types );
				$oReturn				=	null;		//TBD for now no searches...not optimal in SQL anyway.
				break;

			case 'json':
			case 'php':
			case 'xml':
			case 'csvheader':
			case 'fieldslist':
			case 'csv':
			default:
				$oReturn				=	$this->_formatFieldOutputIntBoolFloat( $field->name, $value, $output );
				break;
		}
		return $oReturn;
	}
}//end of MySQL field
?>